#pragma once
#include "ChatItem.h"
#include <deque>

const DWORD ELEMENT_UPDATE_SCROLL = 0;
const DWORD ELEMENT_UPDATE_UNIT   = 1; 

//#define UM_ELEMENT_UPDATE				(WM_USER + 11601)


#define DEF_CHAT_MSG_TIME			1
#define DEF_CHAT_MSG_USERNAME		2
#define DEF_CHAT_MSG_DATE		    4
#define DEF_CHAT_MSG_ISMINE         8
#define DEF_CHAT_MSG_RESEND			16

#define BUBBLE_SYSMSG_FONT_SIZE				(9)
#define PLAIN_SYSMSG_FONT_SIZE				(9)

#define DEF_DATE_POS_TOP_REL_Y				(8)

#define DEF_CHAT_MSG_BUBBLE_ARROR_X			(6)
#define DEF_ITEM_POS_LEFT_REL_X				(10)
#define DEF_ITEM_POS_RIGHT_REL_X			(10)

#define BUBBLE_TIME_MARGIN_X				(8)
#define BUBBLE_TIME_MARGIN_Y				(11)
#define BUBBLE_STATUS_MARGIN_X				(5)

#define DEF_CHAT_MSG_BUBBLE_TOP_Y		(6)
#define PLAIN_STATUS_LEFT_X				(7)

#define BUBBLE_NAME_POS_TOP_REL_X			(6)
#define BUBBLE_NAME_POS_TOP_REL_Y			(4)
#define USER_IMAGE_POS_TOP_REL_Y		(15)
#define BUBBLE_TIME_POS_TOP_REL_Y           (15)

#define  PLAIN_MESSAGE_POS_LEFT_PAD		(10)
#define  DEF_NAME_FONT_HEIGHT		(9)
#define	 PLAIN_NAME_POS_LEFT_REL_X	(10)
#define	 PLAIN_NAME_POS_TOP_REL_Y	(1)
#define	 PLAIN_TIME_POS_RIGHT_X		(12)
#define  PLAIN_TIME_POS_TOP_Y	    (9)
#define  PLAIN_MSG_POS_TOP_Y	    (7)

#define DEF_CHAT_MSG_ITEM_TOP_Y		(20)
#define  PLAIN_TIME_FONT_HEIGHT		(11)


#define BUBBLE_DATE_FONT_SIZE				(8)
#define BUBBLE_NAME_FONT_SIZE				(9)
#define BUBBLE_TIME_FONT_SIZE				(9)

#define DEF_SEND_COUNT_FONT_SIZE			(8)

#define  PLAIN_USERNAME_COLOR	   (Color(255, 136, 136, 136))
#define  PLAIN_TIME_COLOR		   (Color(255, 136, 136, 136))

#define DEF_CHAT_DATE_TXT_COLOR				Color(255, 255, 255, 255)
//#define DEF_CHAT_TIME_TXT_COLOR				Color(CColorConvert::HEX2Color(0X7284a0))
#define DEF_CHAT_USERNAME_TXT_COLOR			Color(255, 0, 0, 0)

#define BUBBLE_CHAT_MSG_SEND_STATUS_X		(20)
#define BUBBLE_CHAT_MSG_SEND_STATUS_Y		(35)
#define BUBBLE_CHAT_MSG_SEND_STATUS_GAP_X	(9)
#define BUBBLE_CHAT_MSG_SEND_STATUS_GAP_Y	(4)

#define DEF_CHAT_MSG_BUBBLE_ARROR_RIGHT_X	(93)

#define BUBBLE_TIME_FORMAT _T("%s %02d:%02d")
#define PLAIN_TIME_FORMAT _T("[%s %02d:%02d:%02d]")

#define DEF_CHAT_BLACK_TXT_COLOR Color(255, 0, 0, 0)
#define DEF_CHAT_WHITE_TXT_COLOR Color(255, 255, 255, 255)

#define TOOLTIP_MAX_WIDTH		(300)

class UIElement;
class CChatMainView;

class IUIElementResouce
{
public:
	virtual ~IUIElementResouce() {};

	virtual Image* GetSysMsgBGImage()    = 0;
	virtual Image* GetSysMsgArrowImage() = 0;
	virtual Image* GetImgDateBGImage(int nIndex)   = 0;
	virtual Image* GetStickerImageByID(LPCTSTR strID) = 0;
	virtual CWnd*  GetCurrentWnd() = 0;
	virtual CPoint GetOffSetPoint() = 0;
	virtual Image* GetFileTransferImageByID(UINT ResID) = 0;
	virtual Image* GetFileTransferFileImage(LPCTSTR filename)=0;
	virtual CRect  GetViewRect()    = 0;
	virtual Image* GetDividerImage() = 0;
	virtual Image* GetDownloadImage() = 0;
	virtual Image* GetReDownloadImage() = 0;
	virtual Image* GetCancelSendImage() = 0;
	virtual Image* GetCancelDownloadImage() = 0;
	virtual Image** GetBubbleImage(BOOL bMine) = 0;
	virtual	Image* GetDownloadedImage() = 0;
	virtual	Image* GetSendStatusImage(int nIndex) = 0;
	virtual Image* GetMyBubbleImage(int nIndex) = 0;
	virtual Image* GetUserJoinImage(int nIndex, BOOL bUserJoin) = 0;
	virtual Image* GetBubbleBottomForSendProcessImage(int nIndex) = 0;
	virtual Image* GetBubbleBottomForRecvProcessImage(int nIndex) = 0;
	virtual	Image* GetYourProgressBarImage(int nIndex) = 0;
	virtual Image* GetMyProgressBarImage(int nIndex) = 0;
	virtual Image* GetOtherBubbleImage(int nIndex) = 0;
	virtual Image* GetFailMsgImage()   = 0;

	//note:this will cache image, and will release when destrcotr, don't delete the Image instance
	//pszImageFilePath is relative path to GetAppImgDir
	//virtual Image* GetCacheImageByFilePath(LPCTSTR pszImageFilePath) = 0;

	virtual BOOL   IsMouseSelection() = 0;
	virtual CPoint GetSelectionStartPoint() = 0;
	virtual void   SetCursor(int nCursor) = 0;
	virtual void   InvalidateElement(UIElement* pElement, BOOL bCalcSize) = 0;
	virtual void   ResendChatItem(CChatItem* pChatItem) = 0;
	virtual Image* GetUserImage() = 0;
	virtual void   OpenHyperLink(LPCTSTR strUrl) = 0;
	virtual void   StartFileTransfer(CChatItem* pChatItem) = 0;
	virtual void   CancelFileTransfer(CChatItem* pChatItem) = 0;
	virtual int    GetChatDisplayType() = 0;
	virtual void    SetTestChatDisplayType(int nType) = 0;
};
class UIElement
{
public:
	UIElement(CChatItem* pChatItem, IUIElementResouce* pResouce);
	virtual ~UIElement(void);

	virtual BOOL Draw( Graphics *graph ) = 0;
	virtual CSize CalcSize( const CPoint& ptPos, DWORD dwFlags ) = 0;

	//mouse event handler, default implemention is empty
	//TODO: assign m_rcItem when CalcSize and here can check it
	virtual void OnLButtonDown(UINT nFlags, CPoint point);
	virtual void OnMouseHover(UINT nFlags, CPoint point);
	virtual void OnLButtonUp(UINT nFlags, CPoint point) {}
	virtual void OnLButtonDblClk( UINT nFlags, CPoint point ) {}
	virtual void OnRButtonUp( UINT nFlags, CPoint point ) {}
	virtual BOOL OnMouseMove( UINT nFlags, CPoint point );
	virtual BOOL HandleToolTip(UINT nFlags, CPoint point, bool bOnlyHandleRemove = false);
	virtual void OnMouseLeave();

	LPChatItemInfo GetChatItemInfo() { return m_pChatItem->GetChatItemInfo(); };
	CChatItem* GetChatItem() {return m_pChatItem;}
	BOOL IsContainPoint(const CPoint& point)const;
	BOOL IsSameChatItem(CChatItem* pChatItem) {return pChatItem == m_pChatItem;}
	void EnableRetryButton(BOOL bEnable);
	BOOL IsEnableRetryButton();

	CString GetTimeString();
	CString GetDateString();

	CRect GetElementRect() { return m_rcItem; }
	DWORD GetCurrentFlags() { return m_dwFlags; }
	void ResetSelectRange();
	CChatMainView *GetChatMainView();
	void SetChatMainView(CChatMainView * pCharMainView);
	

protected:
	void DrawRetryStatus(Graphics* graph, CRect rcPS);

	void  DrawChatText(Graphics* pGraph, CString strText, CRect* pRtPS, CRect* pRtText, WCHAR* wszFontName, REAL nFontHeight,
		Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style, Color crPen, BOOL bSelected, int nSelStart, int nSelEnd);

	void DrawChatText(Graphics* pGraph, CChatItem* pChItem, const CString& strDrawText, CRect* pRtPS, CRect* pRtText,
		Gdiplus::StringAlignment alignment, Color crPen, LPTextRange pRange, const std::vector<TextRange>& vcRange);

	
	void DrawChatText(Graphics* pGraph, const CString& strDrawText, 
		CRect* pRtPS, CRect* pRtText,
		WCHAR* wszFontName, REAL nFontHeight,
		Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style,
		Color crPen, LPTextRange pRange, const std::vector<TextRange>& vcRange, BOOL bWrap = TRUE);

	void DrawChatText(Graphics* pGraph, CString strText, CRect* pRtPS, CRect* pRtText, WCHAR* wszFontName, REAL nFontHeight,
		Gdiplus::StringFormat& format, Gdiplus::FontStyle style, Color crPen, BOOL bSelected, int nSelStart, int nSelEnd);

	void CalcDateSize(const CPoint& ptPos, CSize& sz);
	void DrawDate(Graphics* graph);

	void CalcTime(const CPoint& ptPos, CSize& sz, DWORD dwFlag);
	void DrawTime(Graphics* graph,BOOL bNear=FALSE);

	void CalcUserImage( const CPoint& ptPos, CSize& sz );
	void DrawUserImage(Graphics* graph);

	void CalcUserName(const CPoint& ptPos, CSize& sz);
	void DrawUserName(Graphics* graph);

	
	void NormalizePoint(CPoint& ptStart, CPoint& ptEnds);
	void PlainNormalizePoint(CPoint& ptStart, CPoint& ptEnds);

	//Image* _GetUserImage(int nIndex);
	UINT  _GetUserImageWidth();
	UINT  _GetUserImageHeight();
	void  _SetSelectedItem(CPoint ptStart, CPoint ptEnd, BOOL bSelectWord, const CRect& rect, CString str, Gdiplus::Font* font, LPTextRange lpRange);
	void  _SetTimeSlectedItem(CPoint ptStart, CPoint ptEnd, BOOL bSelectWord);
	void  _SetNameSlectedItem(CPoint ptStart, CPoint ptEnd, BOOL bSelectWord);
	int   _GetStringIndexUnderPoint( const CPoint& ptPos, const CRect& rect, CString str, Gdiplus::Font* font );
	void  _CheckUserMessageRange(CPoint ptStart, CPoint ptEnd, LPTextRange lpRange );
	void  _GetNormalTextRange(const TextRange& range, 
		const std::vector<TextRange>& vecExcludeRanges, std::vector<TextRange>* pNormalRanges);
	

protected:
	CChatMainView	  *m_pChatMainView;
	CChatItem*         m_pChatItem;
	DWORD              m_dwFlags;
	IUIElementResouce* m_pResouce;
	CRect              m_rcDate;
	CRect			   m_rcDateText;
	CRect              m_rcUserName;
	CRect			   m_rcUserImage;
	CRect              m_rcItem;
	CRect              m_rcTime;
	CRect			   m_rcBubble;

	Color              m_crTimeText;
    Color              m_crUserNameText;
	Color			   m_crReSendCount;

	REAL               m_rlBubbleTimeFont;
	REAL               m_rlBubbleUserNameFont;

	REAL               m_rlPlainTimeFont;
	REAL               m_rlPlainUserNameFont;
	

	//Image*			m_pImgUser[2];
	vector<CString> m_vecMsgLines;
	vector<CRect>   m_vecMsgRects;

	bool			m_bTooltipExists;
	CRect			m_rcReSendImg;

	bool			m_bAddToolTip;
	BOOL			m_bEnableRetryButton;

};
typedef std::deque<UIElement*> VectorUIElement;